	.model large
	.DATA
TABEL	db 11, 10, 12, 9
_VTO32L	DW 0
_VTO32H DW 0
_VTO32  Dw 0, 0
PUBLIC _VTO32L
PUBLIC _VTO32H
PUBLIC _VTO32

	.CODE

PUBLIC  _RESET
PUBLIC  _READBYTE
PUBLIC  _WRITEBYTE
PUBLIC  _READBYTEW
PUBLIC  _ACHTTO32L
PUBLIC  _ACHTTO32H
PUBLIC  _MIRROR
PUBLIC  _VIERTO32

arg_org         equ     6       ; large model

_READBYTE       PROC
					 push    bp
					 mov     bp, sp
					 mov     ax, [bp+argu]
					 push    bx
					 mov     bx, ax
					 PUSH    DX              ; save gebruikte registers
					 mov     ah, 0
					 MOV     DX,bx           ; laadt statusregister adres
					 ADD     DX,2
					 IN      AL,DX           ; lees statusregister
					 TEST    AL,00100000B    ; test op input buffer full
					 JZ      LEESBYTE1       ; spring indien geen byte ontvangen
					 mov     ah, 0ffh        ; op -1 als er wat ontvangen is
					 SUB     DX,2            ; poortadres verlagen
					 IN      AL,DX           ; lees data
;               mov     al,0            ; wek de indruk goed te zijn
LEESBYTE1:      POP     DX              ; herstel dx register
					 pop     bx
					 pop     bp
					 RET                     ; einde routine
_READBYTE       ENDP

_READBYTEW      PROC
					 push    bp
					 mov     bp, sp
					 mov     ax, [bp+argu]
					 push    bx
					 mov     bx, ax
					 PUSH    DX              ; save gebruikte registers
					 mov     ah, 0           ;
LEESBYTE2:      MOV     DX,bx           ; laadt statusregister adres
					 ADD     DX,2
					 IN      AL,DX           ; lees statusregister
					 TEST    AL,00100000B    ; test op input buffer full
					 JZ      LEESBYTE2       ; spring indien geen byte ontvangen
					 MOV     DX,bx           ; poortadres verlagen
					 IN      AL,DX           ; lees data
					 POP     DX              ; herstel dx register
					 pop     bx
					 pop     bp
					 RET                     ; einde routine
_READBYTEW      ENDP

_WRITEBYTE      PROC
argu    equ arg_org
					 push    bp
					 mov     bp, sp
					 mov     ax, [bp+argu]   ; First argument
					 PUSH		BX
					 MOV     BX, AX
					 push    dx
					 mov     ax, [bp+argu+2] ; Second argument
					 PUSH    aX              ; Save gebruikte registers
					 MOV     DX,BX           ; Laadt adres statusregister
					 ADD     DX,2
ZENDBYTE1:      IN      AL,DX           ; Lees statusregister
					 TEST    AL,00000010B    ; Test op output buffer empty
					 JZ      ZENDBYTE1       ; Spring als vorig teken niet gelezen
					 DEC     DX              ; Poortadres verlagen
					 POP     AX              ; Haal data van stack
					 OUT     DX,AL           ; Verstuur data
					 POP     DX              ; Herstel dx
					 pop		bx
					 pop     bp
					 RET                     ; Einde routine
_WRITEBYTE      ENDP

_RESET          proc
                push    bp
                mov     bp, sp
                mov     ax, [bp+argu]
		MOV     DX, ax         ; Laadt adres command register 8255
                ADD     DX,3
		push    dx
		mov     al, 0b4h        ; Laadt de gegevens
		out     dx, al
                mov     al, 0fh
		out     dx, al
                pop     dx
                MOV     AL,0EH          ; Geef resetpuls
		OUT     DX,AL           ; PC7 Laag
                MOV     CX,00FFH        ; Wacht korte tijd
RESETPAUSE:     LOOP    RESETPAUSE
                MOV     AL,0FH          ;
                OUT     DX,AL           ; PC7 Hoog
                pop     bp
                ret                     ; Terug jij
_RESET          endp

_MIRROR         proc
		push    bp
                mov     bp, sp
		mov     ax, [bp+argu]
		push    bx                      ; zet bx veilig
		mov     bx, ax                  ; copieer argument
                and     bx, 1fh                 ; bewaar de laagste 5 bits
		xor     ax, bx                  ; snoep die van arg. af
                push    bx                      ; bewaar
                mov     bx, 17e0h               ; bereken complement van scherm
		sub     bx, ax                  ; trek arg er van af
                mov     ax, bx                  ; zet terug in ax
                pop     bx
                or      ax, bx                  ; zet de 5 bits er weer bij
                pop     bx                      ; restore bx
                pop     bp                      ; terug naar C
                ret
_MIRROR         endp

_ACHTTO32L      PROC
		push    bp
		mov     bp, sp
		mov     ax, [bp+argu]
		mov     bx, ax
		mov     cx, 4
lusje1:         mov     dx,0
		shl     ax, 3
		shl     bl, 1
		jnc     weg1
		mov     dx, 0eh
weg1:           rcl     ax, 1
		or      ax, dx
		loop    lusje1
		pop     bp
		ret
_ACHTTO32L      ENDP

_ACHTTO32H      PROC
		push    bp
		mov     bp, sp
		mov     ax, [bp+argu]
		and     ax, 000fh
		shl     ax, 4
		mov     bx, ax
                mov     cx, 4
lusje2:         mov     dx,0
		shl     ax, 3
		shl     bl, 1
		jnc     weg2
		mov     dx, 0eh
weg2:           rcl     ax, 1
		or      ax, dx
		loop    lusje2
		pop     bp
		ret
_ACHTTO32H      ENDP

_VIERTO32	PROC
		push    bp
		mov     bp, sp
		mov     bx, [bp+argu]	; byte met kleuren
		mov	cx, 4		; byte bevat 4 punten
lus01:		push	bx		; bewaar byte voor de volgende ronde
		and	bx, 3		; gebruik de 2 topbits als index
		push	cx
		mov	cx, 4
lus02:		shl	ax, 1
		rcl	dx, 1
		loop	lus02
		or	al, tabel[bx]
		mov	cx, 4
lus03:		shl	ax, 1
		rcl	dx, 1
		loop	lus03
		or	al, tabel[bx]
		pop	cx
		pop	bx
		shr	bx, 2
		loop	lus01
		mov	_VTO32H, dx
		mov	_VTO32L, ax
		mov	_VTO32, dx
		mov	_VTO32+2, ax
		pop     bp
		ret
_VIERTO32       ENDP
     END
